
# Current changelog

## Version 2.1.0 - 2022-07-20

- Adds `outputLinearTextures` property to `createOptions`.
- Adds support for new colorspace behavior in Three `>=0.133.0`.

## Version 2.0.0 - 2022-06-17

- Plugin has been refactored into separate WebGL-only and three.js modules, and can be optionally imported with npm from the GitHub npm registry.

## Version 1.4.0 - 2022-03-18

- Adds seeking functionality. See the `startTime` openOptions parameter and `HoloVideoObjectThreeJS.seekToTime` API for more details.

## Version 1.3.10 - 2022-03-04

- Properly handle switching from capture w/normals to capture w/out normals, and vice versa.

## Version 1.3.9 - 2022-02-01

- Fixes iPod touch devices not being considered valid iOS devices by plugin.

## Version 1.3.8 - 2021-09-30

- Playback in Mozilla WebXR Viewer for iOS 15 has been fixed.

## Version 1.3.7 - 2021-08-25

- Fixed compatibility with Safari 15 on macOS
- `StreamMode.Automatic` now resolves to `StreamMode.MP4` in macOS Safari 14.x (but continues to resolve to `StreamMode.HLS` in Safari 15+). See `Known Limitations` for more details.

## Version 1.3.6 - 2021-08-13

- iOS 15 is supported as of this release. Prior releases will not work correctly on iOS 15 unless `WebGL2` is manually disabled in the Safari `Experimental Features` settings.
- A problem has been resolved where captures would occasionally not loop correctly in Firefox for macOS.

## Version 1.3.5 - 2021-07-26

- Add support for captures with 32-bit index data. `OES_element_index_uint` extension is required for 32-bit index support on WebGL1.

## Version 1.3.4 - 2021-07-14

- `StreamMode.Automatic` now resolves to `StreamMode.HLS` on the Mozilla WebXR Viewer for iOS. Previously `StreamMode.Dash` was being selected which does not appear to be functional in this browser.
- It's recommended that `dashjs` player `v3.2.2` is used with the plugin as `v4.0` (which `cdn.dashjs.org/latest` resolves to as of this update) doesn't appear to work properly.
- WebGL context restore has been fixed

## Version 1.3.3 - 2021-07-06

- Major performance improvement in WebGL1 playback path (mainly affects iOS).
- Add optional `errorCallback` parameter to `HoloVideoObjectThreeJS` constructor. See HoloVideoObject docs for more info.

## Version 1.3.2 - 2021-05-04

- Removes MP4 workaround for iOS 14.6 and above.
- HoloVideoObject state is now set to `Opened` instead of `Opening` at end of video.

## Version 1.3.1 - 2021-02-17

- Fixes issue where a few frames were missing at the end in WebGL2.
- Rewinding now recognizes `keepAllMeshesInMemory` option and does not clear memory.
- End-of-stream now sets holograms to their correct state, which fixes an issue with visibility changes.

## Version 1.3.0 - 2021-02-02

- Major performance improvements.
- HoloVideoObjectThreeJS.Open now accepts `keepAllMeshesInMemory` as an option. When set to `true`, all .bin segments are kept in memory which results in no further mesh loading after the initial one at the cost of higher memory footprint.

## Version 1.2.9 - 2020-10-07

- HoloVideoObjectThreeJS does not require a patched version of three.js anymore. The latest versions of three.js, including r120 and above, can be used without any custom modification.

## Version 1.2.8 - 2020-09-23

- Temporarily redirects iOS/iPadOS 14 users to use MP4 until [Webkit bug](https://bugs.webkit.org/show_bug.cgi?id=215908) is fixed. Because Safari on iPadOS does not relay system version info, this fix does not work for those users.

## Version 1.2.7 - 2020-08-19

- Fixes a bug where having only one THREE.Mesh in the scene would make it disappear on hologram playback.

## Version 1.2.6 - 2020-08-03

- Fixes bug in index buffer management.

## Version 1.2.5.1 - 2020-07-31

- Confirms patch and plugin works with three.js r119.

## Version 1.2.5 - 2020-07-29

- HoloVideoObjectThreeJS now works with a patched version of three.js r118

- Adds ability to force a streamMode parameter when opening a hologram file. (Used only for debugging.)

## Version 1.2.4 - 2020-03-31

- Added HoloVideoObject.VideoStates
```
    Undefined:0,
    CanPlay:1,
    CanPlayThrough:2,
    Waiting:3,
    Suspended:4,
    Stalled:5
```
Read as [holovideoobjectJS].***hvo***.videoState

Don't forget this is a property of the hvo owned by your holovideoobject!

## Version 1.2.3 - 2020-01-27

- HoloVideoObjectThreeJS constructor now accepts callback function for currentFrame

## Version 1.2.2 - 2019-11-26

- API documentation has been added for the `HoloVideoObjectThreeJS` class. See [holovideoobject.md](holovideoobject.md).

## Version 1.2.1 - 2019-11-12

- A bug has been fixed where playback would fail to start under Chrome simulated iOS Device Mode.

## Version 1.1.1 - 2019-10-31

- A bug has been fixed where a capture would appear with a corrupted texture and playback would be unable to proceed.

## Version 1.1.0 - 2019-10-30

- HoloVideoObjectThreeJS.Open now accepts `minBuffers` and `maxBuffers` options. `minBuffers` specifies how many .bin segments the player will download and cache before beginning playback, and `maxBuffers` is the maximum number of bin segments it will keep in memory at one time. An example of settings these options is shown below:

~~~~ts
hvo.open('mycapture.hcap', {minBuffers:5, maxBuffers:8});
~~~~

Previous versions of the player used an effective 'maxBuffers' value of 3 and 'minBuffers' value of 2 (these remain the default values if not explicitly specified).

## Version 1.0.0 - 2019-08-15

- WebGL context loss/reset is handled correctly now.

## Version 0.3.1 - 2019-07-19

- HoloVideoObjectThreeJS.Open now accepts an 'autoplay' field on the 'options' parameter as shown below:

~~~~ts
hvo.open('mycapture.hcap', {autoloop:true, autoplay: true});
~~~~

This will automatically start playback as soon as the capture is finished loading. Since automatic playback of audio content is not allowed by many browsers, this option will automatically mute the capture audio. It can be re-enabled from a user input event by calling `HoloVideoObjectThreeJS.setAudioEnabled(true)`.