import { HoloVideoObject, States } from "@MixedRealityCaptureStudios/holo-video-object";
import { HoloVideoObjectProxy } from "@MixedRealityCaptureStudios/holo-video-object/dist/src/holoVideoObjectProxy";
import { HoloVideoThreeBackend } from "@MixedRealityCaptureStudios/holo-video-object/dist/src/holoVideoThreeBackend";
import * as Three from "three";
export class HoloVideoObjectThreeJS extends HoloVideoObjectProxy {
    mesh;
    _createHoloVideoObject(createOptions, updateCurrentFrameCallback, errorCallback) {
        return new HoloVideoObject(new HoloVideoThreeBackend(createOptions._renderer), createOptions, errorCallback);
    }
    constructor(renderer, callback, createOptions, updateCurrentFrameCallback, errorCallback) {
        super(() => void 0, {
            _renderer: renderer,
            outputLinearTextures: renderer.outputEncoding === Three.sRGBEncoding,
            gl: renderer.getContext(),
            ...createOptions,
        }, updateCurrentFrameCallback, errorCallback);
        const curOnLoaded = this.hvo.onLoaded.bind(this.hvo);
        this.hvo.onLoaded = (fileInfo) => {
            curOnLoaded(fileInfo);
            this.mesh = this.hvo.getGraphicBackend().getMesh();
            callback(this.mesh);
        };
    }
}
export { States };
//# sourceMappingURL=holovideoobject-three.js.map