import { HoloVideoObject, States, ErrorStates } from "./holovideoobject";
import { FileInfo, OpenOptions, HoloVideoCreateOptions } from "./holoVideoInterface";
export declare abstract class HoloVideoObjectProxy {
    onEndOfStream: any;
    hvo: HoloVideoObject;
    state: States;
    fileInfo: FileInfo;
    private _hvoOnEndOfStream;
    protected abstract _createHoloVideoObject(createOptions?: HoloVideoCreateOptions, updateCurrentFrameCallback?: (frame: number) => void, errorCallback?: (type: ErrorStates, info?: Error | MediaError) => void): HoloVideoObject;
    constructor(callback: () => void, createOptions?: HoloVideoCreateOptions, updateCurrentFrameCallback?: (frame: number) => void, errorCallback?: (type: ErrorStates, info?: Error | MediaError) => void);
    open(url: string, options: OpenOptions): void;
    update(): void;
    rewind(): void;
    seekToTime(seekTime: number, displayImmediately: boolean): void;
    play(): void;
    close(): void;
    pause(): void;
    setLogLevel(level: number): void;
    setAudioEnabled(enabled: boolean): void;
    audioEnabled(): boolean;
    setAudioVolume(volume: number): void;
    setAutoLooping(loop: boolean): void;
}
